//  WIDGET.H
//
//  David Stafford
//
//  11/25/91


#ifndef __WIDGET_H
#define __WIDGET_H


#ifndef LINKABLE
  #define CDIST FAR
  #define DDIST FAR
#else
  #ifndef CDIST
    #define CDIST FAR
  #endif

  #ifndef DDIST
    #define DDIST FAR
  #endif

  #define  GetWidgetExtra( Widget )         ((char *)(Widget) + sizeof(WIDGET))
  #define  GetWidgetRect( Widget, Rec )     ((*(Rec)) = (Widget)->Rect)
  #define  GetWidgetImage( Widget )         ((Widget)->Image)
  #define  GetWidgetMask( Widget )          ((Widget)->Mask)
  #define  GetWidgetSize( Widget )          ((Widget)->Size)
  #define  GetWidgetPoint( Widget )         (*(POINT *)&((Widget)->Rect.left))
  #define  IsWidgetVisible( Widget )        ((Widget)->Visible > 0)
#endif


typedef struct tagWIDGET
  {
  HWND              Wnd;              // Window which "owns" the widget
  POINT             Size;             // Width and height of the widget
  RECT              Rect;             // Location within the window
  HBITMAP           Image;            // The widget image
  HBITMAP           Mask;             // (Optional) 1-plane AND mask
  HBITMAP           Background;       // Behind the widget
  int               Visible;          // Widget is visible if > 0
  BOOL              Dirty;            // For repaint
  struct tagWIDGET *Next;             // You guessed it
  }
WIDGET;

typedef WIDGET NEAR * HWIDGET;


typedef struct
  {
  HDC     DC;
  HWIDGET Widget;
  int     Speed;
  DWORD   StartTime;
  int     Distance;
  int     Count;
  }
ANIM_DATA;


// Some handy general-purpose bitmap functions

HBITMAP      CDIST PASCAL CombineBitmaps( HBITMAP Dest, HBITMAP Src1, HBITMAP Src2, DWORD Rop );
void         CDIST PASCAL DrawBitmap( HDC DC, int x, int y, HBITMAP Image, HBITMAP Mask );

// The widget-works

HWIDGET      CDIST PASCAL CreateWidget( HWND Wnd, HBITMAP Image, HBITMAP Mask, int Extra );
void         CDIST PASCAL MoveWidget( HDC DC, HWIDGET Widget, int x, int y );
void         CDIST PASCAL AnimateWidget( HDC DC, HWIDGET Widget, int x, int y, int Speed, HINSTANCE Instance );
void         CDIST PASCAL DestroyWidget( HWIDGET Widget );
void         CDIST PASCAL HideWidget( HDC DC, HWIDGET Widget );
void         CDIST PASCAL AbsHideWidget( HDC DC, HWIDGET Widget );
void         CDIST PASCAL ShowWidget( HDC DC, HWIDGET Widget );
void         CDIST PASCAL AbsShowWidget( HDC DC, HWIDGET Widget );
void         CDIST PASCAL RepaintWidgets( HDC DC, HWND Wnd );
HWIDGET      CDIST PASCAL WidgetHitTest( HWND Wnd, int x, int y );
void         CDIST PASCAL InvalidateWidgetsForPaint( HWND Wnd );
BOOL         CDIST PASCAL IsPointInWidget( HWIDGET Widget, int x, int y );
HWIDGET      CDIST PASCAL GetNextWidget( HWND Wnd, HWIDGET Widget );
int          CDIST PASCAL GetVersionNumber( void );
void         CDIST PASCAL DestroyAllWidgetsForTheWindow( HWND Wnd );
int          CDIST PASCAL DistanceInPoints( int x1, int y1, int x2, int y2 );
BOOL         CDIST PASCAL IntersectWidgetRect( HWIDGET Widget, RECT DDIST *Rect, RECT DDIST *Inter );
BOOL         CDIST PASCAL WidgetsOverlap( HWIDGET Widget1, HWIDGET Widget2 );

#ifndef LINKABLE
void DDIST * CDIST PASCAL GetWidgetExtra( HWIDGET Widget );
void         CDIST PASCAL GetWidgetRect( HWIDGET Widget, RECT DDIST *Rect );
POINT        CDIST PASCAL GetWidgetSize( HWIDGET Widget );
POINT        CDIST PASCAL GetWidgetPoint( HWIDGET Widget );
BOOL         CDIST PASCAL IsWidgetVisible( HWIDGET Widget );
#endif

#endif
